<?php

	abstract class Upload{
	
		protected $dir; // папка
		protected $mime_types; // тип
		
		public function uploadFile($file){ // передаём файл и проверяем на безопасность
			if (!$this->isSecurity($file)) return false;
			$uploadfile = $this->dir."/".$file["name"];
			return move_uploaded_file($file["tmp_name"], $uploadfile);
		
		}
		
		// Проверка на тип
		protected function isSecurity($file){
			$blacklist = array("php",".phtml",".php3",".php4",".html",".htm");
			foreach ($blacklist as $item){
				if(preg_match("/$item=\$/i", $file["name"])) return false;
			}
			$type = $file["type"];
			for ($i = 0; $i < count($this->mime_types); $i++){
				if ($type == $this->mime_types[$i]) break;
				if ($i + 1 == count($this->mime_types)) return false;
			}
		// проверка на размер
			$size = $file["size"];
			if ($size > 2048000) return false;
			return true;
		}
	}
?>